/* $Header: /src/carson/nistnet/RCS/nistspy.h,v 1.1 1998/01/23 15:13:26 carson Exp $ */

#ifndef _NISTSPY_H
#define _NISTSPY_H

/* nistspy.h - Linux implementation of UDP "spy" functionality */

/* structure used for requesting the nistspy hitbox */
struct lin_spyreq {
	__u32	src;		/* source/destination to hit */
	__u32	dest;
	unsigned short	srcport;
	unsigned short	destport;
	__u32	newdest;	/* use 0 to mean send to me */
	unsigned short	newdestport;
};

#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/udp.h>
#include <linux/icmp.h>
#include <linux/igmp.h>

/* ioctl's */

#define SPYIOCTL_OFF	_IO('y', 0)	/* master switch */
#define SPYIOCTL_ON	_IO('y', 1)
#define SPYIOCTL_ADD	_IOW('y', 2, struct lin_spyreq)
#define SPYIOCTL_REMOVE	_IOW('y', 3, struct lin_spyreq)
#define SPYIOCTL_DEBUG	_IOW('y', 8, int)

/* Kernel stuff */
#ifdef __KERNEL__
/* Hash table for hitbox entries */
struct lin_spybox {
	struct lin_spyreq spy;
	struct lin_spybox *next;
};
#endif


#endif /* _NISTNET_H */
